; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{Scenario_Dir}\OUTPUT\ATTRACTIONRATE.PRN" MSG='Attraction Rates File'
FILEO RECO[1] = "{Scenario_Dir}\OUTPUT\ARATES.DBF",
FIELDS=PURPOSE,ARATEIND,ARATECOM,ARATESVC,ARATETOT,ARATEDUS,ARATESCH
FILEI RECI = "{Catalog_Dir}\Parameters\ATTRRATES.DBF"

PURPOSE=RI.ATTR_PURPO
ARATEIND=RI.INEMP_RATE
ARATECOM=RI.COEMP_RATE
ARATESVC=RI.SEEMP_RATE
ARATETOT=RI.TOEMP_RATE
ARATEDUS=RI.TOTDU_RATE
ARATESCH=RI.SCHOO_RATE

WRITE RECO=1
; The MATRIX module does not have any explicit phases.  The module does run within an implied ILOOP
; where I is the origin zones.  All user statements in the module are processed once for each origin.
; Matrix computation (MW[#]=) are solved for all values of J for each I.  Thus for a given origin zone I
; the values for all destination zones J are automatically computed.  The user can control the computations
; at each J by using a JLOOP.

ENDRUN
